searchNodes=[{"type":"module","title":"Pgvector","doc":"A vector struct for pgvector","ref":"Pgvector.html"},{"type":"function","title":"Pgvector.from_binary/1","doc":"Creates a new vector from its binary representation","ref":"Pgvector.html#from_binary/1"},{"type":"function","title":"Pgvector.new/1","doc":"Creates a new vector from a list, tensor, or vector","ref":"Pgvector.html#new/1"},{"type":"function","title":"Pgvector.to_binary/1","doc":"Converts the vector to its binary representation","ref":"Pgvector.html#to_binary/1"},{"type":"function","title":"Pgvector.to_list/1","doc":"Converts the vector to a list","ref":"Pgvector.html#to_list/1"},{"type":"function","title":"Pgvector.to_tensor/1","doc":"Converts the vector to a tensor","ref":"Pgvector.html#to_tensor/1"},{"type":"module","title":"Pgvector.Ecto.Query","doc":"Distance functions for Ecto","ref":"Pgvector.Ecto.Query.html"},{"type":"macro","title":"Pgvector.Ecto.Query.cosine_distance/2","doc":"Returns the cosine distance","ref":"Pgvector.Ecto.Query.html#cosine_distance/2"},{"type":"macro","title":"Pgvector.Ecto.Query.l2_distance/2","doc":"Returns the L2 distance","ref":"Pgvector.Ecto.Query.html#l2_distance/2"},{"type":"macro","title":"Pgvector.Ecto.Query.max_inner_product/2","doc":"Returns the negative inner product","ref":"Pgvector.Ecto.Query.html#max_inner_product/2"},{"type":"module","title":"Pgvector.Ecto.Vector","doc":"","ref":"Pgvector.Ecto.Vector.html"},{"type":"function","title":"Pgvector.Ecto.Vector.cast/1","doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Pgvector.Ecto.Vector.html#cast/1"},{"type":"function","title":"Pgvector.Ecto.Vector.dump/1","doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Pgvector.Ecto.Vector.html#dump/1"},{"type":"function","title":"Pgvector.Ecto.Vector.embed_as/1","doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Pgvector.Ecto.Vector.html#embed_as/1"},{"type":"function","title":"Pgvector.Ecto.Vector.equal?/2","doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Pgvector.Ecto.Vector.html#equal?/2"},{"type":"function","title":"Pgvector.Ecto.Vector.load/1","doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Pgvector.Ecto.Vector.html#load/1"},{"type":"function","title":"Pgvector.Ecto.Vector.type/0","doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Pgvector.Ecto.Vector.html#type/0"},{"type":"module","title":"Pgvector.Extensions.Vector","doc":"","ref":"Pgvector.Extensions.Vector.html"},{"type":"function","title":"Pgvector.Extensions.Vector.decode/1","doc":"","ref":"Pgvector.Extensions.Vector.html#decode/1"},{"type":"function","title":"Pgvector.Extensions.Vector.encode/1","doc":"","ref":"Pgvector.Extensions.Vector.html#encode/1"},{"type":"function","title":"Pgvector.Extensions.Vector.format/1","doc":"","ref":"Pgvector.Extensions.Vector.html#format/1"},{"type":"function","title":"Pgvector.Extensions.Vector.init/1","doc":"","ref":"Pgvector.Extensions.Vector.html#init/1"},{"type":"function","title":"Pgvector.Extensions.Vector.matching/1","doc":"","ref":"Pgvector.Extensions.Vector.html#matching/1"},{"type":"extras","title":"pgvector-elixir","doc":"pgvector support for Elixir Supports Ecto and Postgrex","ref":"readme.html"},{"type":"extras","title":"pgvector-elixir - Installation","doc":"Add this line to your application’s mix.exs under deps : { :pgvector , &quot;~&gt; 0.2.0&quot; } And follow the instructions for your database library: Ecto Postgrex Or check out an example: Embeddings with OpenAI","ref":"readme.html#installation"},{"type":"extras","title":"pgvector-elixir - Ecto","doc":"Create lib/postgrex_types.ex with: Postgrex.Types . define ( MyApp.PostgrexTypes , [ Pgvector.Extensions.Vector ] ++ Ecto.Adapters.Postgres . extensions ( ) , [ ] ) And add to config/config.exs : config :my_app , MyApp.Repo , types : MyApp.PostgrexTypes Create a migration mix ecto.gen.migration create_vector_extension with: defmodule MyApp.Repo.Migrations.CreateVectorExtension do use Ecto.Migration def up do execute &quot;CREATE EXTENSION IF NOT EXISTS vector&quot; end def down do execute &quot;DROP EXTENSION vector&quot; end end Run the migration mix ecto.migrate You can now use the vector type in future migrations create table ( :items ) do add :embedding , :vector , size : 3 end Update the model schema &quot;items&quot; do field :embedding , Pgvector.Ecto.Vector end Insert a vector alias MyApp . { Repo , Item } Repo . insert ( % Item { embedding : [ 1 , 2 , 3 ] } ) Get the nearest neighbors import Ecto.Query import Pgvector.Ecto.Query Repo . all ( from i in Item , order_by : l2_distance ( i . embedding , [ 1 , 2 , 3 ] ) , limit : 5 ) Also supports max_inner_product and cosine_distance Convert a vector to a list or Nx tensor item . embedding |&gt; Pgvector . to_list ( ) item . embedding |&gt; Pgvector . to_tensor ( ) Add an approximate index in a migration create index ( &quot;items&quot; , [ &quot;embedding vector_l2_ops&quot; ] , using : :ivfflat ) # or create index ( &quot;items&quot; , [ &quot;embedding vector_l2_ops&quot; ] , using : :hnsw ) Use vector_ip_ops for inner product and vector_cosine_ops for cosine distance","ref":"readme.html#ecto"},{"type":"extras","title":"pgvector-elixir - Postgrex","doc":"Register the extension Postgrex.Types . define ( MyApp.PostgrexTypes , [ Pgvector.Extensions.Vector ] , [ ] ) And pass it to start_link { :ok , pid } = Postgrex . start_link ( types : MyApp.PostgrexTypes ) Enable the extension Postgrex . query! ( pid , &quot;CREATE EXTENSION IF NOT EXISTS vector&quot; , [ ] ) Create a table Postgrex . query! ( pid , &quot;CREATE TABLE items (embedding vector(3))&quot; , [ ] ) Insert a vector Postgrex . query! ( pid , &quot;INSERT INTO items (embedding) VALUES ($1)&quot; , [ [ 1 , 2 , 3 ] ] ) Get the nearest neighbors Postgrex . query! ( pid , &quot;SELECT * FROM items ORDER BY embedding &lt;-&gt; $1 LIMIT 5&quot; , [ [ 1 , 2 , 3 ] ] ) Convert a vector to a list or Nx tensor vector |&gt; Pgvector . to_list ( ) vector |&gt; Pgvector . to_tensor ( ) Add an approximate index Postgrex . query! ( pid , &quot;CREATE INDEX ON items USING ivfflat (embedding vector_l2_ops) WITH (lists = 100)&quot; , [ ] ) # or Postgrex . query! ( pid , &quot;CREATE INDEX ON items USING hnsw (embedding vector_l2_ops)&quot; , [ ] ) Use vector_ip_ops for inner product and vector_cosine_ops for cosine distance","ref":"readme.html#postgrex"},{"type":"extras","title":"pgvector-elixir - Upgrading","doc":"0.2.0 Vectors are now returned as Pgvector structs instead of lists. Get a list with: vector |&gt; Pgvector . to_list ( ) or an Nx tensor with: vector |&gt; Pgvector . to_tensor ( )","ref":"readme.html#upgrading"},{"type":"extras","title":"pgvector-elixir - History","doc":"View the changelog","ref":"readme.html#history"},{"type":"extras","title":"pgvector-elixir - Contributing","doc":"Everyone is encouraged to help improve this project. Here are a few ways you can help: Report bugs Fix bugs and submit pull requests Write, clarify, or fix documentation Suggest or add new features To get started with development: git clone https://github.com/pgvector/pgvector-elixir.git cd pgvector-elixir mix deps.get createdb pgvector_elixir_test mix test","ref":"readme.html#contributing"}]